//
//  AppDelegate.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/9.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "AppDelegate.h"
#import "ACloudLib.h"
#import "ACKeyChain.h"
#import "UserDefaultUtils.h"
#import "UMessage.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    //测试环境
    [ACloudLib setMode:ACLoudLibModeTest Region:ACLoudLibRegionChina];
    //打开SDK日志
    [ACloudLib setLogEnabled:YES];
    if ([UserDefaultUtils getMajorDomain].length != 0 &&
        [UserDefaultUtils getMajorDomainId] > 0) {
        [ACloudLib setMajorDomain:[UserDefaultUtils getMajorDomain]
                    majorDomainId:[UserDefaultUtils getMajorDomainId]];
    }
    // 友盟
    [UMessage startWithAppkey:@"5790a7d6e0f55a9a3c00035b" launchOptions:nil];
    [UMessage registerForRemoteNotifications];
    [UMessage setLogEnabled:YES];
    [UMessage setAutoAlert:NO];
    
    
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 10.f) {
        //iOS10必须加下面这段代码。
        UNUserNotificationCenter *center = [UNUserNotificationCenter currentNotificationCenter];
        center.delegate = (id)self;
        UNAuthorizationOptions types10 = UNAuthorizationOptionBadge|  UNAuthorizationOptionAlert|UNAuthorizationOptionSound;
        [center requestAuthorizationWithOptions:types10     completionHandler:^(BOOL granted, NSError * _Nullable error) {
            if (granted) {
                //点击允许
                //这里可以添加一些自己的逻辑
            } else {
                //点击不允许
                //这里可以添加一些自己的逻辑
            }
        }];
    }
    return YES;
}

- (void)application:(UIApplication *)application didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken {
    NSString *deviceTokenString = [[[[deviceToken description] stringByReplacingOccurrencesOfString:@"<"withString:@""]
                                    stringByReplacingOccurrencesOfString:@">" withString:@""]
                                   stringByReplacingOccurrencesOfString:@" " withString:@""];
    NSLog(@"deviceToken is %@", deviceTokenString);
    [UMessage registerDeviceToken:deviceToken];
}

//iOS10新增：处理前台收到通知的代理方法
- (void)userNotificationCenter:(UNUserNotificationCenter *)center
       willPresentNotification:(UNNotification *)notification
         withCompletionHandler:(void (^)(UNNotificationPresentationOptions))completionHandler{
    NSMutableDictionary * userInfo = notification.request.content.userInfo.mutableCopy;
    if ([notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        //应用处于前台时的远程推送接受
        [UMessage didReceiveRemoteNotification:userInfo];
        NSLog(@"%@", [NSJSONSerialization JSONObjectWithData:[userInfo[@"_ac_alarm"] dataUsingEncoding:NSUTF8StringEncoding]
                                                     options:NSJSONReadingAllowFragments
                                                       error:nil]);
    } else {
        //应用处于前台时的本地推送接受
    }
    //当应用处于前台时提示设置，需要哪个可以设置哪一个
    completionHandler(UNNotificationPresentationOptionSound|UNNotificationPresentationOptionBadge);
}
//iOS10新增：处理后台点击通知的代理方法
- (void)userNotificationCenter:(UNUserNotificationCenter *)center didReceiveNotificationResponse:(UNNotificationResponse *)response withCompletionHandler:(void (^)())completionHandler{
    NSDictionary * userInfo = response.notification.request.content.userInfo;
    if([response.notification.request.trigger isKindOfClass:[UNPushNotificationTrigger class]]) {
        //应用处于后台时的远程推送接受
        //必须加这句代码
        [UMessage didReceiveRemoteNotification:userInfo];
        
    }else{
        //应用处于后台时的本地推送接受
    }
    
}


@end
