//
//  DeviceListLightCelll.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/26.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "DeviceListLightCelll.h"
#import "ACUserDevice.h"
#import "DeviceMsg.h"

@interface DeviceListLightCelll()
/** 设备信息显示 */
@property (weak, nonatomic) IBOutlet UILabel *deviceMsg;
/** 开关灯按钮 */
@property (weak, nonatomic) IBOutlet UISwitch *switchLight;

/**
 * 控制开关灯状态
 */
- (IBAction)swithLightState:(UISwitch *)sender;

@end
@implementation DeviceListLightCelll

- (void)awakeFromNib {
    // Initialization code
    [super awakeFromNib];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

+ (instancetype)defaultTableView:(UITableView*)tableView deviceMsg:(DeviceMsg *)msg{
    static NSString *ID = @"DeviceListLightCelll";
    DeviceListLightCelll *cell = [tableView dequeueReusableCellWithIdentifier: ID];
    if (cell == nil) {
        cell = [[[NSBundle mainBundle]loadNibNamed:ID owner:nil options:nil]lastObject];
    }
    NSMutableAttributedString *name = [[NSMutableAttributedString alloc]
                                       initWithString:msg.device.deviceName attributes:@{}];
    NSMutableAttributedString *state = [[NSMutableAttributedString alloc]
                                        initWithString:[NSString stringWithFormat:@"\n%@",[self textWithStatus:msg.device.status]]
                                        attributes:@{
                                                     NSForegroundColorAttributeName:[UIColor grayColor],
                                                     NSFontAttributeName:[UIFont systemFontOfSize:11.0f]
                                                     }];
    [name appendAttributedString:state];
    cell.deviceMsg.attributedText = name;
    cell.switchLight.on = msg.isLightOn;
    return cell;
}

+ (NSString *)textWithStatus:(NSInteger)status {
    NSString *text = @"未知状态";
    switch (status) {
        case ACDeviceStatusOffline:
            text = @"不在线";
            break;
        case ACDeviceStatusNetworkOnline:
            text = @"云端在线";
            break;
        case ACDeviceStatusLocalOnline:
            text = @"局域网在线";
            break;
        case ACDeviceStatusBothOnline:
            text = @"云端和局域网同时在线";
            break;
    }
    return text;
}


- (IBAction)swithLightState:(UISwitch *)sender {
    if (self.delegate != nil) {
        if ([self.delegate respondsToSelector:@selector(deviceListLightCelll:lightOperation:)]) {
            [self.delegate deviceListLightCelll:self lightOperation:sender.on ? LightOperationOpen : LightOperationClose];
        }
    }
}
@end
