//
//  LoginViewController.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/9.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "LoginViewController.h"
#import "ACAccountManager.h"
#import "MBProgressHUD+MJ.h"
#import "ACloudLib.h"
#import "ACDeviceMsg.h"
#import "AppDelegate.h"
#import "CustomTableAlertView.h"
#import "ACBindManager.h"
#import "ACNotificationManager.h"

@interface LoginViewController ()//<UITextFieldDelegate>

//帐号输入框
@property (weak, nonatomic) IBOutlet UITextField *accountText;

//密码输入框
@property (weak, nonatomic) IBOutlet UITextField *passwordText;

//登录按钮
@property (weak, nonatomic) IBOutlet UIButton *loginBut;

//切换测试环境按钮
@property (weak, nonatomic) IBOutlet UIButton *routerButton;

//登录按钮点击事件
- (IBAction)loginButClick:(UIButton *)sender;

@end

@implementation LoginViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self textFieldChage:nil];
    //[ACloudLib setHost:@"http://proxy.ablecloud.cn:5000"];
    
    //addTarget 监听用户是否输入
    [self.accountText addTarget:self action:@selector(textFieldChage:) forControlEvents:UIControlEventEditingChanged];
    [self.passwordText addTarget:self action:@selector(textFieldChage:) forControlEvents:UIControlEventEditingChanged];
}


-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    //点击界面  结束输入
    [self.view endEditing:YES];
}


-(void)viewDidAppear:(BOOL)animated
{
    self.accountText.text = [[NSUserDefaults standardUserDefaults] valueForKey:@"user_account"]?:@"";
    [super viewDidAppear:animated];
    [self.accountText becomeFirstResponder];
}
/**
 *  点击登录事件
 */
- (IBAction)loginButClick:(UIButton *)sender {
    
    [MBProgressHUD showMessage:@"正在登录...."];
    NSString *account = self.accountText.text;
    NSString *password = self.passwordText.text;
    [ACAccountManager loginWithAccount:account password:password callback:^(NSString *uid, NSError *error) {
        [ACNotificationManager addAliasWithUserId:uid.integerValue callback:^(NSError *error) {
            if (error) {
                NSLog(@"推送添加别名失败 , %lu",error.code);
            }
        }];
        dispatch_async(dispatch_get_main_queue(), ^{
            //用户合法
            if (error == nil) {
                
                [MBProgressHUD hideHUD];
                [self performSegueWithIdentifier:@"login2main" sender:nil];
                NSLog(@"uid:%@",uid);
                [[NSUserDefaults standardUserDefaults] setValue:self.accountText.text forKey:@"user_account"];
            }else //用户不合法
            {
                NSLog(@"errorerror:%@",error);
                [MBProgressHUD hideHUD];
                [MBProgressHUD showError:@"登录信息错误"];
            }
        });
    }];
}

/**
 *  跳转之前调用
 */
-(void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    UITabBarController *tabBarController = segue.destinationViewController;
    tabBarController.navigationItem.title = @"AbleCloud";
}


#pragma mark 当输入框输入发生改变时调用
-(void)textFieldChage:(UITextField *)textField
{
    self.loginBut.enabled = [self.accountText.text length] && [self.passwordText.text length];
}
@end
