//
//  OTAController.m
//  ac-service-ios-Demo
//
//  Created by __zimu on 16/3/22.
//  Copyright © 2016年 OK. All rights reserved.
//

#import "OTAController.h"
#import "ACOTACheckInfo.h"
#import "ACOTAManager.h"
#import "ACFileManager.h"
#import "ACBindManager.h"
#import "ACAccountManager.h"

@interface OTAController () <UIAlertViewDelegate>
@property (nonatomic, strong) ACOTAUpgradeInfo *upgradeInfo;
@end

@implementation OTAController

- (void)viewDidLoad {
    [super viewDidLoad];
}

#pragma mark - 蓝牙设备OTA
- (IBAction)checkUpdate:(id)sender {
    ACOTACheckInfo *checkInfo = [ACOTACheckInfo checkInfoWithPhysicalDeviceId:@"26C392036EF41B6B"
                                                                      version:@"0-0-1"];
    
    [ACOTAManager checkUpdateWithSubDomain:@"update"
                              OTACheckInfo:checkInfo
                                  callback:^(ACOTAUpgradeInfo *checkInfo, NSError *error) {
                                      if (error) {
                                          NSLog(@"错误信息%@", error);
                                          return;
                                      }
                                      if (!checkInfo.update) {
                                          NSLog(@"不需要升级");
                                          return;
                                      }
                                      //提示是否下载ota文件
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示"
                                                        message:@"是否下载OTA文件"
                                                       delegate:self
                                              cancelButtonTitle:@"取消"
                                              otherButtonTitles:@"确认", nil];
                                      alert.tag = 1;
                                      [alert show];
    }];
}

#pragma mark - 非蓝牙设备OTA
- (IBAction)wifiDownload:(id)sender {
    ACOTACheckInfo *checkInfo = [ACOTACheckInfo checkInfoWithDeviceId:269 otaType:ACOTACheckInfoTypeSystem];
    [ACOTAManager checkUpdateWithSubDomain:@"embedded" OTACheckInfo:checkInfo callback:^(ACOTAUpgradeInfo *checkInfo, NSError *error) {
        NSLog(@"资源:%@---meta:%@",checkInfo, checkInfo.meta);
        if (!checkInfo.update) {
            NSLog(@"不需要升级");
            return;
        }
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"提示" message:@"是否确认升级" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"确认", nil];
        alert.tag = 2;
        [alert show];
    }];
}


#pragma mark - alertViewDelegate
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    NSLog(@"buttonIndex:%zd", (long)buttonIndex);
    
    if (alertView.tag == 1) {
        if (buttonIndex) {
            [self downloadOTA:_upgradeInfo];
        }
    }
    if (alertView.tag == 2) {
        if (buttonIndex) {
            [self confirmUpdate];
        }
    }
}

#pragma mark - private
- (void)confirmUpdate {
    [ACOTAManager confirmUpdateWithSubDomain:@"embedded"
                                    deviceId:269
                                  newVersion:@""
                                     otaType:ACOTACheckInfoTypeCustom
                                    callback:^(NSError *error) {
                                        NSLog(@"确认升级:%@", error);
                                    }];
}

- (void)downloadOTA:(ACOTAUpgradeInfo *)checkInfo {
    ACFileManager *manager = [[ACFileManager alloc] init];
    [manager downFileWithsession:checkInfo.meta.downloadUrl checkSum:checkInfo.meta.checksum callBack:^(float progress, NSError *error) {
        NSLog(@"%f---error:%@", progress, error);
        
    } CompleteCallback:^(NSString *filePath) {
        //发送下载完成请求
        NSLog(@"下载完成:%@", filePath);
        [self otaFinished];
    }];
}

- (void)otaFinished {
    [ACOTAManager otaMediaDoneWithSubDomain:@"azota1" PhysicalDeviceId:@"26C392036EF41B6B" currentVersion:@"0-0-1" targetVersion:@"0-0-2" otaType:1 callback:^(NSError *error) {
        NSLog(@"ota成功:%@", error);
    }];
}



@end
