//
//  RegisterViewController.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/9.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "RegisterViewController.h"
#import "ACAccountManager.h"
#import "MBProgressHUD+MJ.h"



@interface RegisterViewController ()
// phoneNum UITextField
@property (weak, nonatomic) IBOutlet UITextField *phoneNumText;
//e-mail  UITextField
@property (weak, nonatomic) IBOutlet UITextField *emailText;
//password UITextField
@property (weak, nonatomic) IBOutlet UITextField *passwordText;
//password2  UITextField
@property (weak, nonatomic) IBOutlet UITextField *password2;
//verify  UITextField
@property (weak, nonatomic) IBOutlet UITextField *verifyText;

/**
 *  申请验证码
 */
- (IBAction)verifyButClick:(UIButton *)sender;

/**
 *  注册用户
 */
- (IBAction)registerButClick:(UIButton *)sender;

@end

@implementation RegisterViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    [self.view endEditing:YES];
}
-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [self.phoneNumText becomeFirstResponder];
}

- (IBAction)verifyButClick:(UIButton *)sender {
    NSString *phoneNum = self.phoneNumText.text;
    [MBProgressHUD showMessage:@"正在获取验证码"];
    [ACAccountManager sendVerifyCodeWithAccount:phoneNum template:1 callback:^(NSError *error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            if (error == nil) {
                [MBProgressHUD hideHUD];
                [MBProgressHUD showSuccess:@"成功发送验证码"];
            }else
            {
                [MBProgressHUD hideHUD];
                [MBProgressHUD showError:@"获取失败"];
                NSLog(@"获取验证码(error)：%@",error);
            }
        });
    }];
}

- (IBAction)registerButClick:(UIButton *)sender {
    [MBProgressHUD showMessage:@"正在注册。。。"];
    
    NSString *phoneNum = self.phoneNumText.text;
    NSString *email = self.emailText.text;
    NSString *password = self.passwordText.text;
    NSString *verify = self.verifyText.text;
    
    NSString *password2 = self.password2.text;
    //判断两次的密码是不是一致 不一致直接返回
    if (![password isEqualToString:password2]) {
        [MBProgressHUD hideHUD];
        [MBProgressHUD showError:@"密码不一致"];
        return;
    }
    
    [ACAccountManager registerWithPhone:phoneNum email:email password:password verifyCode:verify callback:^(NSString *uid, NSError *error) {
        dispatch_async(dispatch_get_main_queue(), ^{
            
            if (error == nil) { //注册成功
                [MBProgressHUD hideHUD];
                [MBProgressHUD showSuccess:@"注册成功"];
                dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                    [self.navigationController popViewControllerAnimated:YES];
                    
                });
            }else //注册失败
            {
                NSLog(@"registerErroe:%@",error);

                [MBProgressHUD hideHUD];
                [MBProgressHUD showError:@"注册失败"];
            }
        });
    }];
}

@end
