//
//  SetupDomainViewController.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/9.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "SetupDomainViewController.h"
#import "ACloudLib.h"
#import "MBProgressHUD+MJ.h"
#import "UserDefaultUtils.h"

@interface SetupDomainViewController ()
//domain UITextField
@property (weak, nonatomic) IBOutlet UITextField *domainText;
//domain UITextField
@property (weak, nonatomic) IBOutlet UITextField *DomainIDText;
//subDomain UITextField
@property (weak, nonatomic) IBOutlet UITextField *subDomain;
//demoService UITextField
@property (weak, nonatomic) IBOutlet UITextField *demoServiceText;
//demoServiceNum UITextField
@property (weak, nonatomic) IBOutlet UITextField *demoServiceNumText;
/**
 *  设置domian subdomain
 */
- (IBAction)setupButClick:(UIButton *)sender;

@end

@implementation SetupDomainViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    [self.view endEditing:YES];
}

-(void)viewWillAppear:(BOOL)animated {
    self.domainText.text = [UserDefaultUtils getMajorDomain] ? : @"";
    self.DomainIDText.text = @([UserDefaultUtils getMajorDomainId]).stringValue;
    self.subDomain.text = [UserDefaultUtils getSubDomain];
    [super viewDidAppear:animated];
    [self.domainText becomeFirstResponder];
}

- (IBAction)setupButClick:(UIButton *)sender {
    NSString *domain = self.domainText.text;
    NSInteger domainID = [self.DomainIDText.text integerValue];
    NSString *subDomain = self.subDomain.text;
    
    [ACloudLib setMajorDomain:domain majorDomainId:domainID];
    [UserDefaultUtils setMajorDomain:domain domainId:domainID];
    [UserDefaultUtils setSubDomain:subDomain];
    
    if([ACloudLib getMajorDomain] != nil && [domain length]){
        [MBProgressHUD showSuccess:@"设置成功"];
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(1.0 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [self.navigationController popViewControllerAnimated:YES];
        });
    }else{
        [MBProgressHUD showError:@"设置失败"];
    }
}
@end
