//
//  ShowTimeLine.m
//  ac-service-ios-Demo
//
//  Created by OK on 15/2/26.
//  Copyright (c) 2015年 OK. All rights reserved.
//

#import "ShowTimeLine.h"
#import "ACMsg.h"
#import "ACloudLib.h"
#import "DeviceMsg.h"

#define SCREENHEIGHT [[UIScreen mainScreen] bounds].size.height
#define SCREENWIDTH [[UIScreen mainScreen]bounds].size.width
#define HORIZONTALLINEWIDTH 8
#define VERTICALLINEWIDTH 4
#define LABELWIDTH 150
#define LABELHEIGHT 20

@interface ShowTimeLine ()
@property(nonatomic,strong) UIScrollView *scrollView;
@end

@implementation ShowTimeLine

- (void)viewDidLoad {
    [super viewDidLoad];
    UIScrollView *scrollView = [[UIScrollView alloc]initWithFrame:[[UIScreen mainScreen] bounds]];
    scrollView.showsVerticalScrollIndicator = NO;
    [self.view addSubview:scrollView];
    self.scrollView = scrollView;
}

+ (instancetype)showTimeLine:(NSArray *)list {
    ShowTimeLine *showTimeLine = [[ShowTimeLine alloc]init];
    showTimeLine.view.backgroundColor = [UIColor whiteColor];
    CGFloat contentHeight = 55+[list count]*44;
    showTimeLine.scrollView.contentSize = CGSizeMake(0, contentHeight);
    
    //设置最顶端的view
    CGFloat topViewWidth = 240;
    CGFloat topViewX = (SCREENWIDTH -240)*0.5;
    CGFloat topViewY = 35;
    CGFloat topViewHeight = HORIZONTALLINEWIDTH;
    UIView *topView =[[UIView alloc]initWithFrame:CGRectMake(topViewX, topViewY, topViewWidth, topViewHeight)];
    topView.backgroundColor = [UIColor yellowColor];
    [showTimeLine.scrollView
     addSubview:topView];
    
    //设置竖直的
    CGFloat verticalHeight = [list count] *44;
    CGFloat verticalX = (SCREENWIDTH - VERTICALLINEWIDTH) * 0.5;
    CGFloat verticalY = (topViewY + topViewHeight);
    CGFloat verticalWeight = VERTICALLINEWIDTH;
    UIView *verticalView = [[UIView alloc]initWithFrame:CGRectMake(verticalX, verticalY, verticalWeight, verticalHeight)];
    verticalView.backgroundColor = [UIColor yellowColor];
    [showTimeLine.scrollView addSubview:verticalView];
    //标记等的状态
    CGFloat leftX = verticalX - LABELWIDTH;
    CGFloat rightX = verticalX + verticalWeight + 5;
    CGFloat Y = topViewY + 20;
    for (int i = 0; i < [list count]; i++) {
        if (i % 2 == 0) {
            UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(leftX, Y, LABELWIDTH, LABELHEIGHT)];
            [label.init setText:list[i]];
            UIView *view = [[UIView alloc]initWithFrame:CGRectMake(leftX - 10, Y + LABELHEIGHT, LABELWIDTH + 10, 3)];
            view.backgroundColor = [UIColor yellowColor];
            [showTimeLine.scrollView addSubview:view];
            [showTimeLine.scrollView addSubview:label];
        }else
        {
            UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(rightX, Y, LABELWIDTH, LABELHEIGHT)];
            [label.init setText:list[i]];
            UIView *view = [[UIView alloc]initWithFrame:CGRectMake(rightX - 5, Y + LABELHEIGHT, LABELWIDTH + 10, 3)];
            view.backgroundColor = [UIColor yellowColor];
            [showTimeLine.scrollView addSubview:view];
            [showTimeLine.scrollView addSubview:label];
        }
        Y += 44;
    }
    return showTimeLine;
}
@end
