//
//  TestController.m
//  ac-service-ios-Demo
//
//  Created by __zimu on 16/3/11.
//  Copyright © 2016年 OK. All rights reserved.
//

#import "TestController.h"
#import "ACFeedBack.h"
#import "ACFeedBackManager.h"
#import "ACAccountManager.h"
#import "ACBindManager.h"
#import "ACDeviceMsg.h"
#import "ACOTAManager.h"
#import "ACFileManager.h"
#import "ACDeviceManager.h"
#import "ACUserDevice.h"
#import "ACPushManager.h"
#import "ACPM25.h"
#import "ACWeatherManager.h"
#import "pm25ViewController.h"
#import "ACDeviceClient.h"
#import "ACMemoryCacheLocalDevice.h"
#import "ACloudLib.h"
#import "ACFindDevicesManager.h"
#import "ACDeviceActive.h"
#import "ACWifiLinkManager.h"
#import "ACFileInfo.h"

@interface TestController () <ACFindDevicesDelegate>
@property (nonatomic, copy) NSString *account;
@property (nonatomic, copy) NSString *pwd;
@property (nonatomic, copy) NSString *verifyCode;

@property (nonatomic, strong) ACPushTable *table;
@property (nonatomic, copy) NSString *urlString;


@property (nonatomic, copy) NSString *pid;
@end

@implementation TestController

- (ACPushTable *)table {
    if (_table == nil) {
        _table = [[ACPushTable alloc] init];
        _table.opType = OPTYPE_CREATE | OPTYPE_REPLACE | OPTYPE_UPDATE | OPTYPE_DELETE;
        _table.className = @"light_action_data2";
        ACObject *priKey = [[ACObject alloc] init];
        [priKey put:@"deviceId" value:@21];
        _table.primaryKey = priKey;
    }
    return _table;
}

- (IBAction)pm25Action:(id)sender {
    pm25ViewController *pm25Controller = [[pm25ViewController alloc] init];
    pm25Controller.title = @"pm25";
    [self.navigationController pushViewController:pm25Controller animated:YES];
}

- (IBAction)sendToDevice:(id)sender {
    
    Byte content[] ={1,0,0,0};
    NSData *payload = [NSData dataWithBytes:content length:sizeof(content)];
    
    ACDeviceMsg *msg = [[ACDeviceMsg alloc] initWithCode:68 binaryData:payload];
    [msg setSecurityMode:ACDeviceSecurityModeNone];

//    [ACBindManager sendToDeviceWithOption:ACDeviceCommunicationOptionOnlyCloud SubDomain:@"5socket" physicalDeviceId:self.pid msg:msg callback:^(ACDeviceMsg *responseMsg, NSError *error) {
//        NSLog(@"云端发消息给设备结果: %@---%@", responseMsg, error);
//    }];
    
    [ACBindManager sendToDeviceWithOption:ACDeviceCommunicationOptionOnlyLocal SubDomain:@"5socket" physicalDeviceId:self.pid msg:msg callback:^(ACDeviceMsg *responseMsg, NSError *error) {
        NSLog(@"局域网发消息给设备结果: %@---%@", responseMsg, error);
    }];
}

- (IBAction)findDevice:(id)sender {
    NSLog(@"开始局域网发现");
    [[[ACloudLib alloc] init] findDeviceTimeout:3 SudDomainId:0 callback:^(NSArray *localDeviceList) {
        [localDeviceList enumerateObjectsUsingBlock:^(ACLocalDevice *obj, NSUInteger idx, BOOL * _Nonnull stop) {
            NSLog(@"发现到了设备:%@", obj);
            self.pid = obj.deviceId;
        }];
    }];
}

- (IBAction)testEveryThing:(id)sender {

    NSLog(@"开始配网");
    ACWifiLinkManager *manager = [[ACWifiLinkManager alloc] initWithLinkerName:@"CC3x"];
    [manager sendWifiInfo:@"HW_test" password:@"87654321" timeout:30 callback:^(NSArray *localDevices, NSError *error) {
       [localDevices enumerateObjectsUsingBlock:^(ACLocalDevice *obj, NSUInteger idx, BOOL * _Nonnull stop) {
           NSLog(@"配网成功");
           if (obj.deviceId) {
               self.pid = obj.deviceId;
               NSLog(@"pid:%@", obj.deviceId);
//               [ACBindManager bindDeviceWithSubDomain:@"5socket" physicalDeviceId:self.pid name:@"我是设备" callback:^(ACUserDevice *userDevice, NSError *error) {
//                   NSLog(@"绑定结果: %@--%@", userDevice, error);
//               }];
           }
       }];
    }];
}

- (void)activateDevice {
    ACDeviceActive *active = [[ACDeviceActive alloc] init];
    active.physicalDeviceId = @"1234567890";
    active.deviceVersion = @"1";
    active.longitude = 100;
    active.latitude = 100;
    active.mac = @"1234567890";
    
    //设备激活
    [ACDeviceManager activateDeviceWithSubDomain:@"update" DeviceActive:active Callback:^(ACMsg *responseMsg, NSError *error) {
        NSLog(@"设备激活结果:%@--错误信息:%@", responseMsg.name, error);
    }];

}


/// feedback中图片的url的获取, 请使用getDownloadUrl接口
/// key 需要跟前端定义的一致
/// 1. 先将图片上传到云端 2. 获取DownloadeUrl 3. 调用feedback将url作为图片的value
- (IBAction)addFeedBack:(id)sender {
//    [self testActiveBluetooth];
    ACFeedBack *feedback = [[ACFeedBack alloc] init];
    feedback.extend = [[ACObject alloc] init];
    [feedback.extend put:@"description" value:@"123"];
    
//    [feedback addFeedBackWithKey:@"description" value:@"130xxxxxxxx"];
    
    
    [ACFeedBackManager submitFeedBack:feedback callback:^(BOOL isSuccess, NSError *error) {
        NSLog(@"%d---%@", isSuccess, error);
    }];
    //    [feedback addFeedBackPictureWithKey:@"description" value:@"http://7xlg0j.com1.z0.glb.clouddn.com/kafka_partition.jpg"];
    //    [feedback addFeedBackPictureWithKey:@"pictureOne" value:@"http://7xlg0j.com1.z0.glb.clouddn.com/kafka_cluster.png"];
}

//激活设备
- (void)testActiveBluetooth {
    ACDeviceActive * deviceActive = [ACDeviceActive new];
    deviceActive.physicalDeviceId = @"aaaaaaaaaaa";
    deviceActive.deviceVersion = @"1";
    deviceActive.mac = @"bbbbbbbbbbb";
    deviceActive.latitude = 40.0;
    deviceActive.longitude = 120.0;
    [ACDeviceManager activateDeviceWithSubDomain:@"test" DeviceActive:deviceActive Callback:^(ACMsg *responseMsg, NSError *error) {
        NSLog(@"%@---%@", responseMsg.getObjectData, error);
    }];
}


///  上传文件的流程, 只是流程, 由于都是异步请求, 开发者需自己按顺序调用.
- (IBAction)uploadFile {
    
//1. 设置要上传的fileInfo
    ACFileManager *manager = [[ACFileManager alloc] init];
    //checkSum为用户自己上传, 传入0表示不校验
    ACFileInfo *fileInfo = [ACFileInfo fileInfoWithName:@"testUpload" bucket:@"hongyan_https" CheckSum:3342];
    
    //开发者自行选择以下两种方式
    //大文件, 提供filePath, 支持断线续传
    fileInfo.filePath = [[NSBundle mainBundle] pathForResource:@"aaa.mp3" ofType:nil];
    //小文件, 提供data, 不支持短线续传
//    fileInfo.data = data.bytes;

//2. 调用上传接口
    [manager uploadFileWithfileInfo:fileInfo progressCallback:^(float progress) {
        NSLog(@"上传进度:%f", progress);
    } voidCallback:^(ACMsg *responseObject, NSError *error) {
        if (error) {
            //错误处理
            return;
        }
        
        BOOL success = [responseObject.name isEqualToString:ACMsgAckMSG];
        if (success) {
            NSLog(@"上传成功");
        } else {
            NSLog(@"上传失败");
        }
    }];
    
//3. 获取上传信息的url (注: 过期时间为url的过期时间, 而不是文件的过期时间, 传0为永久有效)
    [manager getDownloadUrlWithfile:fileInfo ExpireTime:0 payloadCallback:^(NSString *urlString, NSError *error) {
        if (error) {
            //错误处理
            return;
        }
        NSLog(@"%@", urlString);
    }];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.account = @"13933520376";
    self.pwd = @"123456";
    self.verifyCode = @"testing.ablecloud";
}

@end
