//
//  pm25ViewController.m
//  ac-service-ios-Demo
//
//  Created by __zimu on 16/4/1.
//  Copyright © 2016年 OK. All rights reserved.
//

#import "pm25ViewController.h"
#import "ACWeatherManager.h"
#import "ACPM25.h"

#define _area @"北京"

@interface pm25ViewController ()

@end

@implementation pm25ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self initPM25Button];
    [self initAQIButton];
    [self initWeatherButton];
    self.view.backgroundColor = [UIColor whiteColor];
}

#pragma mark - pm25
- (void)initPM25Button {
    [self initGetLatestPM25Button];
    [self initGetLastDaysPM25Button];
    [self initGetLastHoursPM25Button];
}
- (void)initGetLatestPM25Button {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"PM25" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLatestPM25) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(20, 100, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastDaysPM25Button {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"DaysPM25" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastDaysPM25) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(20, 150, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastHoursPM25Button {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"HoursPM25" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastHoursPM25) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(20, 200, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)getLatestPM25 {
    [ACWeatherManager getLatestPM25WithArea:_area callback:^(ACPM25 *pm25, NSError *error) {
        NSLog(@"%@", pm25);
    }];
}

- (void)getLastDaysPM25 {
    [ACWeatherManager getLastDaysPM25WithArea:_area days:3 callback:^(NSArray *pm25List, NSError *error) {
        [pm25List enumerateObjectsUsingBlock:^(ACPM25 *pm25, NSUInteger idx, BOOL * _Nonnull stop) {
            NSLog(@"%@", pm25);
        }];
    }];
}

- (void)getLastHoursPM25 {
    [ACWeatherManager getLastHoursPM25WithArea:_area hours:12 callback:^(NSArray *pm25List, NSError *error) {
        [pm25List enumerateObjectsUsingBlock:^(ACPM25 *pm25, NSUInteger idx, BOOL * _Nonnull stop) {
            NSLog(@"%@", pm25);
        }];
    }];
}

#pragma mark - aqi

- (void)initAQIButton {
    [self initGetLatestAQIButton];
    [self initGetLastDaysAQIButton];
    [self initGetLastHoursAQIButton];
}

- (void)initGetLatestAQIButton {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"AQI" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLatestAQI) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(140, 100, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastDaysAQIButton {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"DaysAQI" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastDaysAQI) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(140, 150, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastHoursAQIButton {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"HoursAQI" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastHoursAQI) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(140, 200, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)getLatestAQI {
    [ACWeatherManager getLatestAqiWithArea:_area callback:^(ACAQI *aqi, NSError *error) {
        NSLog(@"%@", aqi);
    }];
}

- (void)getLastDaysAQI {
    [ACWeatherManager getLastDaysAqiWithArea:_area days:3 callback:^(NSArray *aqiList, NSError *error) {
       [aqiList enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
           NSLog(@"%@", obj);
       }];
    }];
}

- (void)getLastHoursAQI {
    [ACWeatherManager getLastHoursAqiWithArea:_area hours:7 callback:^(NSArray *aqiList, NSError *error) {
       [aqiList enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
           NSLog(@"%@", obj);
       }];
    }];
}


#pragma mark - weather
- (void)initWeatherButton {
    [self initGetLatestWeatherButton];
    [self initGetLastDaysWeatherButton];
    [self initGetLastHoursWeather5Button];
}

- (void)initGetLatestWeatherButton {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"Weather" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLatestWeather) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(240, 100, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastDaysWeatherButton {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"DaysWeather" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastDaysWeather) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(240, 150, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)initGetLastHoursWeather5Button {
    UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
    [btn setTitle:@"HoursWeather" forState:UIControlStateNormal];
    [btn addTarget:self action:@selector(getLastHoursWeather) forControlEvents:UIControlEventTouchUpInside];
    btn.frame = CGRectMake(240, 200, 100, 30);
    [btn sizeToFit];
    [btn setBackgroundColor:[UIColor blackColor]];
    [self.view addSubview:btn];
}

- (void)getLatestWeather {
    [ACWeatherManager getLatestWeatherWithArea:_area callback:^(ACWeather *weather, NSError *error) {
        NSLog(@"%@", weather);
    }];
}

- (void)getLastDaysWeather {
    [ACWeatherManager getLastDaysWeatherWithArea:_area days:5 callback:^(NSArray *weatherList, NSError *error) {
        [weatherList enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
            NSLog(@"%@", obj);
        }];
    }];
}

- (void)getLastHoursWeather {
   [ACWeatherManager getLastHoursWeatherWithArea:_area hours:11 callback:^(NSArray *weatherList, NSError *error) {
      [weatherList enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
          NSLog(@"%@", obj);
      }];
   }];
}



@end
